package gov.va.med.attachment.spring.model;

import java.util.ArrayList;


public class ClaimAttachments {


	private Integer id;
	private String providerName;
	private String providerIdentifier;
	private String patientFirstName;
	private String patientLastName;
	private String reportCode;
	private String definition;
	private ArrayList <String> codeDefinitions;
	private String patientControlNumber;
	private String medicalRecordNumber;
	private String patientIdentifier;
	private String providerNpi;
	private String claimIdentifier;
	private String claimServiceDate;
	private String claimServiceStartDate;
	private String claimServiceEndDate;
	private String payerClaimControlNumber;
	private String attachmentControlNumber;
	private String loincCode;
	private String status;
	private String[] statusValues = {"A", "D"};
	private String attachmentName;
	private String attachmentType;
	private String ver;
	private byte[] attachment;
	private String message;


	public ClaimAttachments() {
	}

	public ClaimAttachments(String patientControlNumber, 
							String medicalRecordNumber, 
							String patientLastName, 
							String patientFirstName,
							String patientIdentifier,
							String providerNpi,
							String claimServiceStartDate,
							String claimServiceEndDate,
							String payerClaimControlNumber,
							String attachmentControlNumber
							) {
		this.patientControlNumber = patientControlNumber;
		this.medicalRecordNumber  = medicalRecordNumber;
		this.patientLastName      = patientLastName;
		this.patientFirstName     = patientFirstName;
		this.patientIdentifier    = patientIdentifier;
		this.providerNpi          = providerNpi;
		this.claimServiceStartDate   = claimServiceStartDate;
		this.claimServiceEndDate     = claimServiceEndDate;
		this.payerClaimControlNumber = payerClaimControlNumber;
		this.attachmentControlNumber = attachmentControlNumber;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getProviderName() {
		return providerName;
	}

	public void setProviderName(String providerName) {
		this.providerName = providerName;
	}

	public String getProviderIdentifier() {
		return providerIdentifier;
	}

	public void setProviderIdentifier(String providerIdentifier) {
		this.providerIdentifier = providerIdentifier;
	}

	public String getPatientFirstName() {
		return patientFirstName;
	}

	public void setPatientFirstName(String patientFirstName) {
		this.patientFirstName = patientFirstName;
	}

	public String getPatientLastName() {
		return patientLastName;
	}

	public void setPatientLastName(String patientLastName) {
		this.patientLastName = patientLastName;
	}
	
	public String getReportCode() {
		return reportCode;
	}

	public void setReportCode(String reportCode) {
		this.reportCode = reportCode;
	}

	public String getDefinition() {
		return definition;
	}

	public void setDefinition(String definition) {
		this.definition = definition;
	}
	
	public ArrayList<String> getCodeDefinitions() {
		return codeDefinitions;
	}

	public void setCodeDefinitions(ArrayList<String> codeDefinitions) {
		this.codeDefinitions = codeDefinitions;
	}

	public String getPatientControlNumber() {
		return patientControlNumber;
	}

	public void setPatientControlNumber(String patientControlNumber) {
		this.patientControlNumber = patientControlNumber;
	}

	public String getMedicalRecordNumber() {
		return medicalRecordNumber;
	}

	public void setMedicalRecordNumber(String medicalRecordNumber) {
		this.medicalRecordNumber = medicalRecordNumber;
	}

	public String getPatientIdentifier() {
		return patientIdentifier;
	}

	public void setPatientIdentifier(String patientIdentifier) {
		this.patientIdentifier = patientIdentifier;
	}

	public String getProviderNpi() {
		return providerNpi;
	}

	public void setProviderNpi(String providerNpi) {
		this.providerNpi = providerNpi;
	}

	public String getClaimIdentifier() {
		return claimIdentifier;
	}

	public void setClaimIdentifier(String claimIdentifier) {
		this.claimIdentifier = claimIdentifier;
	}
	
	
	public String getClaimServiceDate() {
		return claimServiceDate;
	}

	public void setClaimServiceDate(String claimServiceDate) {
		this.claimServiceDate = claimServiceDate;
	}

	public String getClaimServiceStartDate() {
		return claimServiceStartDate;
	}

	public void setClaimServiceStartDate(String claimServiceStartDate) {
		this.claimServiceStartDate = claimServiceStartDate;
	}

	public String getClaimServiceEndDate() {
		return claimServiceEndDate;
	}

	public void setClaimServiceEndDate(String claimServiceEndDate) {
		this.claimServiceEndDate = claimServiceEndDate;
	}

	public String getPayerClaimControlNumber() {
		return payerClaimControlNumber;
	}

	public void setPayerClaimControlNumber(String payerClaimControlNumber) {
		this.payerClaimControlNumber = payerClaimControlNumber;
	}

	public String getAttachmentControlNumber() {
		return attachmentControlNumber;
	}

	public void setAttachmentControlNumber(String attachmentControlNumber) {
		this.attachmentControlNumber = attachmentControlNumber;
	}
	
	public String getLoincCode() {
		return loincCode;
	}

	public void setLoincCode(String loincCode) {
		this.loincCode = loincCode;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}
	
	public String[] getStatusValues() {
		return statusValues;
	}

	public void setStatusValues(String[] statusValues) {
		this.statusValues = statusValues;
	}

	public String getAttachmentName() {
		return attachmentName;
	}

	public void setAttachmentName(String attachmentName) {
		this.attachmentName = attachmentName;
	}

	public String getAttachmentType() {
		return attachmentType;
	}

	public void setAttachmentType(String attachmentType) {
		this.attachmentType = attachmentType;
	}

	public byte[] getAttachment() {
		return attachment;
	}

	public void setAttachment(byte[] attachment) {
		this.attachment = attachment;
	}

	public String getVer() {
		return ver;
	}

	public void setVer(String ver) {
		this.ver = ver;
	}
	
}
